﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.Planet;
using Verse;
using HarmonyLib;

namespace TROM
{
    [HarmonyPatch(typeof(MapGenerator), "GenerateMap")]
    class PATCH_GenerateMap
    {
        [HarmonyPrefix]
        private static bool TROM_GenerateMap(MapParent parent, ref MapGeneratorDef mapGenerator)
        {
            try
            {
                if (parent.Biome == TROMBiomeDefOf.CityOutskirts || parent.Biome == TROMBiomeDefOf.CityCentral)
                {
                    mapGenerator = TROMDef.TROMBase_Player;
                }
                return true;
            }
            catch (Exception e)
            {
                Log.Warning("TROM: Something went wrong @PATCH_GenerateMap: " + e);
                return true;
            }
        }
    }

    [HarmonyPatch(typeof(GenGrid), "InNoBuildEdgeArea")]
    class PATCH_InNoBuildEdgeArea
    {
        [HarmonyPostfix]
        private static void TROM_InNoBuildEdgeArea(Map map, ref bool __result)
        {
            try
            {
                if (Current.ProgramState == ProgramState.MapInitializing && (map.Biome == TROMBiomeDefOf.CityOutskirts || map.Biome == TROMBiomeDefOf.CityCentral))
                {
                    __result = false;
                }
            }
            catch (Exception e)
            {
                Log.Warning("TROM: Something went wrong @PATCH_InNoBuildEdgeArea: " + e);
            }
        }
    }
}