﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.SketchGen;
using UnityEngine;
using Verse;

namespace TROM
{
    public class IncidentWorker_ShellingNearby : IncidentWorker
    {
        private const int FixedPoints = 30;

        protected override bool CanFireNowSub(IncidentParms parms)
        {
            Map map = (Map)parms.target;

            if (!base.CanFireNowSub(parms))
            {
                return false;
            }
            if (map.Biome == TROMBiomeDefOf.CityCentral || map.Biome == TROMBiomeDefOf.CityOutskirts)
            {
                return true;
            }
            return false;
        }
        
        protected override bool TryExecuteWorker(IncidentParms parms)
        {
            Map map = (Map)parms.target;

            int duration = Mathf.RoundToInt(def.durationDays.RandomInRange * 60000f);
            GameCondition_ShellingNearby gameCondition_ShellingNearby = (GameCondition_ShellingNearby)GameConditionMaker.MakeCondition(TROMDef.GameCondition_ShellingNearby, duration);
            map.gameConditionManager.RegisterCondition(gameCondition_ShellingNearby);
            SendStandardLetter(def.letterLabel, TROMDef.GameCondition_ShellingNearby.letterText, def.letterDef, parms, new TargetInfo(gameCondition_ShellingNearby.centerLocation.ToIntVec3, map));

            return true;
        }
    }
}