﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.SketchGen;
using UnityEngine;
using Verse;

namespace TROM
{
    class SketchResolver_CourtyardShed : SketchResolver
    {
        protected override bool CanResolveInt(ResolveParams parms)
        {
            return true;
        }

        protected override void ResolveInt(ResolveParams parms)
        {
            int width = parms.rect.Value.Width;
            int height = parms.rect.Value.Height;
            Sketch shed = new Sketch();
            bool onlyBuildableByPlayer = parms.onlyBuildableByPlayer ?? false;
            bool filterAllowsAll = parms.allowedMonumentThings == null;

            //start replacement
            bool[,] array = Utility.BoxShapeGenerator.Generate(width, height);
            for (int i = 0; i < array.GetLength(0); i++)
            {
                for (int j = 0; j < array.GetLength(1); j++)
                {
                    if (i == 2 && j == 0)
                    {
                        shed.AddThing(ThingDefOf.Door, new IntVec3(i, 0, j), Rot4.North, ThingDefOf.WoodLog);
                        shed.AddTerrain(TerrainDefOf.WoodPlankFloor, new IntVec3(i, 0, j));
                    }
                    else if (array[i, j])
                    {
                        shed.AddThing(ThingDefOf.Wall, new IntVec3(i, 0, j), Rot4.North, ThingDefOf.WoodLog);
                    }
                    else
                    {
                        shed.AddTerrain(TerrainDefOf.WoodPlankFloor, new IntVec3(i, 0, j));
                    }
                }
            }

            parms.sketch.MergeAt(shed, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ), Sketch.SpawnPosType.Unchanged);
        }
    }
}
