﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.SketchGen;
using UnityEngine;
using Verse;

namespace TROM
{
    class SketchResolver_HouseAlleyway : SketchResolver
    {
        protected override bool CanResolveInt(ResolveParams parms)
        {
            return true;
        }

        protected override void ResolveInt(ResolveParams parms)
        {
            parms.rect = new CellRect(parms.rect.Value.minX, parms.rect.Value.minZ, 2, 9);
            Sketch alleyway = new Sketch();

            for (int i = 0; i < 2; i++)
            {
                for (int j = 0; j < 9; j++)
                {
                    alleyway.AddTerrain(TerrainDefOf.Concrete, new IntVec3(i, 0, j));
                }
            }

            //add debris
            int x = Rand.Range(0, 2);
            alleyway.AddThing(TROMThingDefOf.AncientVendingMachine, new IntVec3(0, 0, Rand.Range(0, 3)), parms.GetCustom<Rot4>("rotation"));
            alleyway.AddThing(TROMThingDefOf.AncientBarrel, new IntVec3(x, 0, Rand.Range(3, 7)), Rot4.North);

            ResolveParams parms2 = parms;
            parms2.sketch = alleyway;
            parms.sketch.MergeAt(alleyway, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ), Sketch.SpawnPosType.Unchanged);
        }
    }
}
