﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.SketchGen;
using Verse;

namespace TROM
{
    class SketchResolver_HouseCorner : SketchResolver
    {
        protected override bool CanResolveInt(ResolveParams parms)
        {
            return true;
        }

        protected override void ResolveInt(ResolveParams parms)
        {
            ThingDef wallMaterial = Utility.Filters.RandStone();

            int width = parms.rect.Value.Width;
            int height = parms.rect.Value.Height;
            int thickness = 7;
            Sketch house = new Sketch();
            bool onlyBuildableByPlayer = parms.onlyBuildableByPlayer ?? false;
            bool filterAllowsAll = parms.allowedMonumentThings == null;

            bool[,] array = Utility.LBoxShapeGenerator.Generate(width, height, thickness);
            for (int i = 0; i < array.GetLength(0); i++)
            {
                for (int j = 0; j < array.GetLength(1); j++)
                {
                    if (array[i, j])
                    {
                        house.AddThing(ThingDefOf.Wall, new IntVec3(i, 0, j), Rot4.North, wallMaterial);
                    }
                }
            }

            ResolveParams parms2 = parms;
            parms2.sketch = house;
            parms2.connectedGroupsSameStuff = true;
            if (parms.addFloors ?? true)
            {
                ResolveParams parms3 = parms;
                parms3.singleFloorType = true;
                parms3.sketch = house;
                parms3.floorFillRoomsOnly = false;
                parms3.onlyStoneFloors = parms.onlyStoneFloors ?? true;
                parms3.allowConcrete = parms.allowConcrete ?? false;
                parms3.rect = new CellRect(0, 0, width, thickness);
                SketchResolverDefOf.FloorFill.Resolve(parms3);
                parms3.rect = new CellRect(0, 0, thickness, height);
                SketchResolverDefOf.FloorFill.Resolve(parms3);
            }
            List<SketchThing> things = house.Things;
            for (int num6 = 0; num6 < things.Count; num6++)
            {
                if (things[num6].def == ThingDefOf.Wall)
                {
                    house.RemoveTerrain(things[num6].pos);
                }
            }

            parms.sketch.MergeAt(house, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ), Sketch.SpawnPosType.Unchanged);
        }
    }
}
