﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.SketchGen;
using UnityEngine;
using Verse;

namespace TROM
{
    class SketchResolver_HouseCorner_R1 : SketchResolver
    {
        public static int x = 11, z = 11;
        bool switche = false;

        protected override bool CanResolveInt(ResolveParams parms)
        {
            return true;
        }

        protected override void ResolveInt(ResolveParams parms)
        {
            parms.rect = new CellRect(parms.rect.Value.minX, parms.rect.Value.minZ, x, z);
            ThingDef wallMaterial = Utility.Filters.RandStone();

            //old
            int width = parms.rect.Value.Width;
            int height = parms.rect.Value.Height;
            Sketch house = new Sketch();
            bool onlyBuildableByPlayer = parms.onlyBuildableByPlayer ?? false;
            bool filterAllowsAll = parms.allowedMonumentThings == null;

            bool[,] array = Utility.BoxShapeGenerator.Generate(width, height);

            //slanted edge
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    if (i + j == 4)
                    {
                        array[i, j] = true;
                    }
                    else
                    {
                        array[i, j] = false;
                    }
                }
            }

            if (Rand.Range(0, 100) > 50)
            {
                array[6, 1] = true;
                array[6, 2] = true;
                array[6, 3] = true;
                array[6, 5] = true;
                array[6, 6] = true;
                array[6, 7] = true;
                array[6, 9] = true;
                array[1, 6] = true;
                array[2, 6] = true;
                array[3, 6] = true;
                array[4, 6] = true;
                array[5, 6] = true;
                array[8, 0] = false;
                switche = false;
            }
            else
            {
                array[1, 6] = true;
                array[2, 6] = true;
                array[3, 6] = true;
                array[5, 6] = true;
                array[6, 6] = true;
                array[7, 6] = true;
                array[9, 6] = true;
                array[6, 1] = true;
                array[6, 2] = true;
                array[6, 3] = true;
                array[6, 4] = true;
                array[6, 5] = true;
                array[0, 8] = false;
                switche = true;
            }

            //add walls
            for (int i = 0; i < array.GetLength(0); i++)
            {
                for (int j = 0; j < array.GetLength(1); j++)
                {
                    if (array[i, j])
                    {
                        house.AddThing(ThingDefOf.Wall, new IntVec3(i, 0, j), Rot4.North, wallMaterial);
                    }
                }
            }

            ResolveParams parms2 = parms;
            parms2.sketch = house;
            parms2.connectedGroupsSameStuff = true;
            if (parms.addFloors ?? true)
            {
                ResolveParams parms3 = parms;
                parms3.singleFloorType = true;
                parms3.sketch = house;
                parms3.floorFillRoomsOnly = false;
                parms3.onlyStoneFloors = parms.onlyStoneFloors ?? true;
                parms3.allowConcrete = parms.allowConcrete ?? false;
                parms3.rect = new CellRect(0, 0, width, height);
                SketchResolverDefOf.FloorFill.Resolve(parms3);
            }
            List<SketchThing> things = house.Things;
            for (int num6 = 0; num6 < things.Count; num6++)
            {
                if (things[num6].def == ThingDefOf.Wall)
                {
                    house.RemoveTerrain(things[num6].pos);
                }
            }

            //add doors
            if (switche == false)
            {
                house.AddThing(ThingDefOf.Door, new IntVec3(8, 0, 0), Rot4.North, ThingDefOf.WoodLog);
                house.AddThing(ThingDefOf.Door, new IntVec3(6, 0, 4), Rot4.East, ThingDefOf.WoodLog);
                house.AddThing(ThingDefOf.Door, new IntVec3(6, 0, 8), Rot4.East, ThingDefOf.WoodLog);
            }
            else
            {
                house.AddThing(ThingDefOf.Door, new IntVec3(0, 0, 8), Rot4.East, ThingDefOf.WoodLog);
                house.AddThing(ThingDefOf.Door, new IntVec3(4, 0, 6), Rot4.North, ThingDefOf.WoodLog);
                house.AddThing(ThingDefOf.Door, new IntVec3(8, 0, 6), Rot4.North, ThingDefOf.WoodLog);
            }

            //add furniture
            if (switche == false)
            {
                if (Rand.Range(0, 100) > 30) house.AddThing(ThingDefOf.AncientBed, new IntVec3(1, 0, 8), Rot4.East);

                if (Rand.Range(0, 100) > 99) house.AddThing(TROMThingDefOf.TubeTelevision, new IntVec3(3, 0, 2), Rot4.North);
                if (Rand.Range(0, 100) > 60) house.AddThing(TROMThingDefOf.Armchair, new IntVec3(4, 0, 5), Rot4.South);
                if (Rand.Range(0, 100) > 95) house.AddThing(ThingDefOf.AncientLamp, new IntVec3(5, 0, 3), Rot4.North);
                if (Rand.Range(0, 100) > 20) house.AddThing(ThingDefOf.PlantPot, new IntVec3(5, 0, 5), Rot4.North);
                if (Rand.Range(0, 100) > 50) house.AddThing(ThingDefOf.Table1x2c, new IntVec3(1, 0, 4), Rot4.North, ThingDefOf.WoodLog);
                if (Rand.Range(0, 100) > 20) house.AddThing(ThingDefOf.DiningChair, new IntVec3(2, 0, 4), Rot4.West, ThingDefOf.WoodLog);
                if (Rand.Range(0, 100) > 75) house.AddThing(ThingDefOf.DiningChair, new IntVec3(2, 0, 5), Rot4.West, ThingDefOf.WoodLog);

                if (Rand.Range(0, 100) > 40) house.AddThing(TROMThingDefOf.AncientStove, new IntVec3(9, 0, 6), Rot4.East);
                if (Rand.Range(0, 100) > 70) house.AddThing(TROMThingDefOf.AncientOven, new IntVec3(9, 0, 7), Rot4.East);
                if (Rand.Range(0, 100) > 10) house.AddThing(TROMThingDefOf.AncientKitchenSink, new IntVec3(9, 0, 5), Rot4.East);
            }
            else
            {
                if (Rand.Range(0, 100) > 30) house.AddThing(ThingDefOf.AncientBed, new IntVec3(8, 0, 1), Rot4.North);

                if (Rand.Range(0, 100) > 99) house.AddThing(TROMThingDefOf.TubeTelevision, new IntVec3(2, 0, 3), Rot4.East);
                if (Rand.Range(0, 100) > 60) house.AddThing(TROMThingDefOf.Armchair, new IntVec3(5, 0, 4), Rot4.West);
                if (Rand.Range(0, 100) > 95) house.AddThing(ThingDefOf.AncientLamp, new IntVec3(3, 0, 5), Rot4.North);
                if (Rand.Range(0, 100) > 20) house.AddThing(ThingDefOf.PlantPot, new IntVec3(5, 0, 5), Rot4.North);
                if (Rand.Range(0, 100) > 20) house.AddThing(ThingDefOf.PlantPot, new IntVec3(5, 0, 5), Rot4.North);
                if (Rand.Range(0, 100) > 50) house.AddThing(ThingDefOf.Table1x2c, new IntVec3(4, 0, 1), Rot4.East, ThingDefOf.WoodLog);
                if (Rand.Range(0, 100) > 20) house.AddThing(ThingDefOf.DiningChair, new IntVec3(4, 0, 2), Rot4.South, ThingDefOf.WoodLog);
                if (Rand.Range(0, 100) > 75) house.AddThing(ThingDefOf.DiningChair, new IntVec3(5, 0, 2), Rot4.South, ThingDefOf.WoodLog);

                if (Rand.Range(0, 100) > 40) house.AddThing(TROMThingDefOf.AncientStove, new IntVec3(6, 0, 9), Rot4.North);
                if (Rand.Range(0, 100) > 70) house.AddThing(TROMThingDefOf.AncientOven, new IntVec3(7, 0, 9), Rot4.North);
                if (Rand.Range(0, 100) > 10) house.AddThing(TROMThingDefOf.AncientKitchenSink, new IntVec3(5, 0, 9), Rot4.North);
            }

            parms.sketch.MergeAt(house, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ), Sketch.SpawnPosType.Unchanged);
        }
    }
}
