﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.SketchGen;
using UnityEngine;
using Verse;

namespace TROM
{
    class SketchResolver_Intersection_Checkpoint : SketchResolver
    {
        protected override bool CanResolveInt(ResolveParams parms)
        {
            return true;
        }

        protected override void ResolveInt(ResolveParams parms)
        {
            Sketch checkpoint = new Sketch();

            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(1, 0, 2), Rot4.North);
            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(1, 0, 5), Rot4.North);
            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(6, 0, 2), Rot4.North);
            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(6, 0, 5), Rot4.North);
            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(2, 0, 1), Rot4.North);
            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(2, 0, 6), Rot4.North);
            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(5, 0, 1), Rot4.North);
            checkpoint.AddThing(TROMThingDefOf.AncientConcreteBarrier, new IntVec3(5, 0, 6), Rot4.North);

            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(0, 0, 1), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(0, 0, 2), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 1), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 0), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(2, 0, 0), Rot4.North);

            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(7, 0, 1), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(7, 0, 2), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 1), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 0), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 0), Rot4.North);

            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(0, 0, 5), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(0, 0, 6), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 6), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 7), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(2, 0, 7), Rot4.North);

            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(7, 0, 5), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(7, 0, 6), Rot4.West);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 6), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 7), Rot4.North);
            checkpoint.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 7), Rot4.North);

            checkpoint.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(2, 0, 2), Rot4.Random);
            checkpoint.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(5, 0, 5), Rot4.Random);
            checkpoint.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(2, 0, 5), Rot4.Random);
            checkpoint.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(5, 0, 2), Rot4.Random);

            parms.sketch.MergeAt(checkpoint, default(IntVec3), Sketch.SpawnPosType.Unchanged);
        }
    }
}
