﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.SketchGen;
using UnityEngine;
using Verse;

namespace TROM
{
    class SketchResolver_Street_Barricade : SketchResolver
    {
        protected override bool CanResolveInt(ResolveParams parms)
        {
            return true;
        }

        protected override void ResolveInt(ResolveParams parms)
        {
            Sketch barricade = new Sketch();

            if (parms.GetCustom<Rot4>("direction") == Rot4.North)
            {
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 6), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 6), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 5), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(2, 0, 5), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(3, 0, 5), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(4, 0, 5), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 5), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 5), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(2, 0, 6), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(5, 0, 6), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(1, 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(3, 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(5, 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(6, 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(2, 4), 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(5, 7), 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(0, 2), 0, 0), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(4, 6), 0, 0), Rot4.North);

                parms.sketch.MergeAt(barricade, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ));
            }
            else if (parms.GetCustom<Rot4>("direction") == Rot4.South)
            {
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 0), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 0), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(2, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(3, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(4, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(2, 0, 0), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(5, 0, 0), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(1, 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(3, 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(5, 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(6, 0, 2), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(0, 2), 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(4, 6), 0, 4), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(2, 4), 0, 6), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(Rand.Range(5, 7), 0, 6), Rot4.North);

                parms.sketch.MergeAt(barricade, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ));
            }
            else if (parms.GetCustom<Rot4>("direction") == Rot4.East)
            {
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(6, 0, 6), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 1), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 2), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 3), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 4), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 5), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(5, 0, 6), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(6, 0, 2), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(6, 0, 5), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 1), Rot4.West);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 2), Rot4.West);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 3), Rot4.West);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 4), Rot4.West);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 5), Rot4.West);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(4, 0, 6), Rot4.West);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(0, 0, Rand.Range(0, 2)), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(0, 0, Rand.Range(4, 6)), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(2, 0, Rand.Range(2, 4)), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(2, 0, Rand.Range(5, 7)), Rot4.North);

                parms.sketch.MergeAt(barricade, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ));
            }
            else if (parms.GetCustom<Rot4>("direction") == Rot4.West)
            {
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(0, 0, 1), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(0, 0, 6), Rot4.North);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 1), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 2), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 3), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 4), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 5), Rot4.East);
                barricade.AddThing(ThingDefOf.Sandbags, new IntVec3(1, 0, 6), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(0, 0, 2), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientSecurityTurret, new IntVec3(0, 0, 5), Rot4.Random);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 1), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 2), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 3), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 4), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 5), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientRazorWire, new IntVec3(2, 0, 6), Rot4.East);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(5, 0, Rand.Range(0, 2)), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(5, 0, Rand.Range(4, 6)), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(3, 0, Rand.Range(2, 4)), Rot4.North);
                barricade.AddThing(ThingDefOf.AncientTankTrap, new IntVec3(3, 0, Rand.Range(5, 7)), Rot4.North);

                parms.sketch.MergeAt(barricade, new IntVec3(parms.rect.Value.minX, 0, parms.rect.Value.minZ));
            }
        }
    }
}
