﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;

namespace TROM
{
    [DefOf]
    public static class TROMBiomeDefOf
    {
        public static BiomeDef CityOutskirts;
        public static BiomeDef CityCentral;

        static TROMBiomeDefOf()
        {
            DefOfHelper.EnsureInitializedInCtor(typeof(BiomeDefOf));
        }
    }

    [DefOf]
    public static class TROMSketchResolverDefOf
    {
        public static SketchResolverDef CourtyardShed;
        public static SketchResolverDef FloorFillSpecific;
        public static SketchResolverDef HouseAlleyway;
        public static SketchResolverDef HouseCorner;
        public static SketchResolverDef HouseCorner_R1;
        public static SketchResolverDef HouseCorner_R2;
        public static SketchResolverDef HouseCorner_RG;
        public static SketchResolverDef HouseEdge;
        public static SketchResolverDef Intersection;
        public static SketchResolverDef Intersection_Checkpoint;
        public static SketchResolverDef Street;
        public static SketchResolverDef Street_Barricade;

        static TROMSketchResolverDefOf()
        {
            DefOfHelper.EnsureInitializedInCtor(typeof(SketchResolverDefOf));
        }
    }

    [DefOf]
    public static class TROMTerrainDefOf
    {
        public static TerrainDef BrokenAsphalt;         //somehow not implemented by base game, don't ask me why
        public static TerrainDef TileGranite;           //somehow not implemented by base game, don't ask me why
        public static TerrainDef TileLimestone;         //somehow not implemented by base game, don't ask me why
        public static TerrainDef TileMarble;            //somehow not implemented by base game, don't ask me why
        public static TerrainDef TileSlate;             //somehow not implemented by base game, don't ask me why
        public static TerrainDef FlagstoneGranite;      //somehow not implemented by base game, don't ask me why
        public static TerrainDef FlagstoneLimestone;    //somehow not implemented by base game, don't ask me why
        public static TerrainDef FlagstoneMarble;       //somehow not implemented by base game, don't ask me why
        public static TerrainDef FlagstoneSlate;        //somehow not implemented by base game, don't ask me why

        static TROMTerrainDefOf()
        {
            DefOfHelper.EnsureInitializedInCtor(typeof(TerrainDefOf));
        }
    }

    [DefOf]
    public static class TROMThingDefOf
    {
        public static ThingDef AncientBarrel;           //somehow not implemented by base game, don't ask me why
        public static ThingDef AncientConcreteBarrier;  //somehow not implemented by base game, don't ask me why
        public static ThingDef AncientKitchenSink;      //somehow not implemented by base game, don't ask me why
        public static ThingDef AncientLamppost;         //somehow not implemented by base game, don't ask me why
        public static ThingDef AncientOven;             //somehow not implemented by base game, don't ask me why
        public static ThingDef AncientStove;            //somehow not implemented by base game, don't ask me why
        public static ThingDef AncientVendingMachine;   //somehow not implemented by base game, don't ask me why
        public static ThingDef Armchair;                //somehow not implemented by base game, don't ask me why
        public static ThingDef BlocksLimestone;         //somehow not implemented by base game, don't ask me why
        public static ThingDef BlocksMarble;            //somehow not implemented by base game, don't ask me why
        public static ThingDef BlocksSandstone;         //somehow not implemented by base game, don't ask me why
        public static ThingDef BlocksSlate;             //somehow not implemented by base game, don't ask me why
        public static ThingDef ChessTable;              //somehow not implemented by base game, don't ask me why
        public static ThingDef ChunkGranite;            //somehow not implemented by base game, don't ask me why
        public static ThingDef ChunkLimestone;          //somehow not implemented by base game, don't ask me why
        public static ThingDef ChunkMarble;             //somehow not implemented by base game, don't ask me why
        public static ThingDef ChunkSandstone;          //somehow not implemented by base game, don't ask me why
        public static ThingDef ChunkSlate;              //somehow not implemented by base game, don't ask me why
        public static ThingDef Shelling_HighExplosive;
        public static ThingDef TubeTelevision;          //somehow not implemented by base game, don't ask me why

        static TROMThingDefOf()
        {
            DefOfHelper.EnsureInitializedInCtor(typeof(ThingDefOf));
        }
    }

    [DefOf]
    class TROMDef
    {
        public static GameConditionDef GameCondition_ShellingNearby;

        public static GenStepDef TROM_ElevationFertility;
        public static GenStepDef TROM_Terrain;
        public static GenStepDef TROM_Streets;
        public static GenStepDef TROM_Blocks;

        public static IncidentDef ShellingNearby;

        public static MapGeneratorDef TROMBase_Player;

        public static SoundDef Shelling_OffMap;

        public static WorldGenStepDef TROM_City;

        static TROMDef()
        {
            DefOfHelper.EnsureInitializedInCtor(typeof(TROMDef));
        }
    }
}
