﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using RimWorld.Planet;
using Verse;
using UnityEngine;

namespace TROM
{
    public class TROMMod : Mod
    {
        /// <summary>
        /// A reference to our settings.
        /// </summary>
        TROMSettings settings;

        /// <summary>
        /// A mandatory constructor which resolves the reference to our settings.
        /// </summary>
        /// <param name="content"></param>
        public TROMMod(ModContentPack content) : base(content)
        {
            this.settings = GetSettings<TROMSettings>();
        }

        /// <summary>
        /// The (optional) GUI part to set your settings.
        /// </summary>
        /// <param name="inRect">A Unity Rect with the size of the settings window.</param>
        public override void DoSettingsWindowContents(Rect inRect)
        {
            Listing_Standard listingStandard = new Listing_Standard();
            listingStandard.Begin(inRect);
            listingStandard.CheckboxLabeled("Generate Player Base Map with TROM", ref settings.generateWithTROM, ".");
            listingStandard.Label("City block size");
            settings.blockSize = listingStandard.Slider(settings.blockSize, 20f, 60f);
            listingStandard.End();
            base.DoSettingsWindowContents(inRect);
        }

        /// <summary>
        /// Override SettingsCategory to show up in the list of settings.
        /// Using .Translate() is optional, but does allow for localisation.
        /// </summary>
        /// <returns>The (translated) mod name.</returns>
        public override string SettingsCategory()
        {
            return "This Rim Of Mine".Translate();
        }
    }
}
